/* 

         (c)  Vladimir Dergachev

         xpmbrowser 2.0

         see accompanying README file for tweaking details

         free for personal enjoyment.

         if you change something please send me a note
         at vdergach@math.upenn.edu with subject xpmbrowser

*/



#include <X11/Xlib.h>
#include <dirent.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>
#include <X11/StringDefs.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Label.h>
#include <X11/xpm.h>
#include "file_types.h"
#include "globals.h"
#include <X11/Xaw/AsciiText.h>
#include "rclick.h"
#include "callbacks.h"
#include "LabelF.h"
#include "CommandF.h"

Widget popup=NULL;

int OnlyOnePopup=0;

int PopupW=160;
int PopupH=210;

#ifndef TRASHDIR
	char *trashDir=".fb/trash/";
#else
	char *trashDir=TRASHDIR;
#endif

char __tmp[2000];

#define FB ((struct FileButton *)pointer)

void DeleteCallback(Widget widget,XtPointer pointer,XtPointer junk)
{
#ifdef __DEBUG__
fprintf(stderr,". ");fflush(stderr);
fprintf(stderr,"Deleting %s of type %d\n",((struct FileButton *)pointer)->filename,((struct FileButton *)pointer)->type);
fflush(stderr);
#endif
sprintf(__tmp,"%s/%s",expand(trashDir),((struct FileButton *)pointer)->name);
if(rename(FB->filename,__tmp)<0){
            fprintf(stderr,"Deleting file \"%s\":",
                ((struct FileButton *)pointer)->filename);
            perror("");
            return ; /* returning ..*/
             }
             

XtUnmanageChild(FB->Button);

XtPopdown(FB->popup);
FB->popup=0;
/*exit(0);*/
}

Pixmap *Recognize_ExtCheck(char *filename,char *dpname);
void ExtCheck_RightClickCallBack(char *);

void EditCallback(Widget widget,XtPointer pointer,XtPointer junk)
{
#ifdef __DEBUG__
fprintf(stderr,". ");fflush(stderr);
fprintf(stderr,"Renaming %s of type %d\n",((struct FileButton *)pointer)->filename,((struct FileButton *)pointer)->type);
fflush(stderr);
printf("%d %d\n",FB->type,patterns[(FB->type)]->R_P==Recognize_ExtCheck);
fflush(stdout);
#endif
if(patterns[(FB->type)]->R_P==Recognize_ExtCheck){
      ExtCheck_RightClickCallback(FB->filename);      
      }

}

void ButtonCallback(Widget widget,XtPointer pointer,XtPointer junk);
char * ExtCheck_RightClickCallbackName(char *filename);

void MakeLayout(Widget popup,Widget top, struct FileButton *fb)
{
struct stat buf;
int numargs;
Arg args[20];
char *size;
Widget Label,OpenButton,DeleteButton,EditButton,NameEdit,Box1,PixmapButton,as;
struct FileButton *fb1;

          numargs=0;
          XtSetArg(args[numargs],XtNborderWidth,0);numargs++;   
          XtSetArg(args[numargs],XtNwidth,10);numargs++;
          XtSetArg(args[numargs],XtNheight,10);numargs++;

     Box1=XtCreateManagedWidget("ButtonBox",boxWidgetClass,top,args,numargs);
         
      XtInsertEventHandler(Box1,ButtonReleaseMask,False,RClickCallback,fb,XtListHead);

          numargs=0;

         XtSetArg(args[numargs],XtNbitmap,*(fb->pixmap));numargs++;   
         
          XtSetArg(args[numargs],XtNborderWidth,0);numargs++;
          XtSetArg(args[numargs],XtNjustify,XtJustifyCenter);numargs++;   
          XtSetArg(args[numargs],"shadowWidth",0);numargs++;
          XtSetArg(args[numargs],XtNcursorName,"hand2");numargs++;
          PixmapButton=XtCreateManagedWidget("commandPixmapWidget",commandFWidgetClass,Box1,args,numargs);
         XtInsertEventHandler(PixmapButton,ButtonReleaseMask,False,RClickCallback,fb,XtListHead);
       
          XtAddCallback(PixmapButton,XtNcallback,ButtonCallback,fb);
          

         numargs=0;
          XtSetArg(args[numargs],XtNborderWidth,0);numargs++;   
          XtSetArg(args[numargs],XtNfromVert,OpenButton);numargs++;
          XtSetArg(args[numargs],XtNjustify,XtJustifyCenter);numargs++;   
          XtSetArg(args[numargs],"shadowWidth",0);numargs++;
          XtSetArg(args[numargs],XtNtitle,fb->name);numargs++;
          XtSetArg(args[numargs],XtNstring,fb->name);numargs++;
          XtSetArg(args[numargs],XtNeditType,XawtextEdit);numargs++;
          XtSetArg(args[numargs],XtNdisplayCaret,TRUE);numargs++;
          XtSetArg(args[numargs],XtNwrap,XawtextWrapNever);numargs++;
          XtSetArg(args[numargs],XtNwidth,strlen(fb->name));
          /*XtSetArg(args[numargs],XtNresize,TRUE);numargs++;
          XtSetArg(args[numargs],XtNscrollHorizontal,XawtextScrollNever);numargs++;*/
          NameEdit=XtCreateManagedWidget("Filename",asciiTextWidgetClass,Box1,args,numargs);
          
          XtVaGetValues(NameEdit,XtNtextSource,&as,NULL);
          
          fb->txtSrc=as;
          XtAddCallback(as,XtNcallback,RenameCallback,fb); 

stat(fb->filename,&buf);

size=calloc(200,sizeof(char));
if(size!=NULL){
          size[0]=0;
          sprintf(size,"Size: %d bytes",(int)buf.st_size);
 
          numargs=0;
          XtSetArg(args[numargs],XtNborderWidth,0);numargs++;   
          XtSetArg(args[numargs],XtNtitle,size);numargs++;          
          XtSetArg(args[numargs],XtNjustify,XtJustifyCenter);numargs++;   
          Label=XtCreateManagedWidget(size,labelWidgetClass,top,args,numargs);
	  free(size);

}
          numargs=0;
          XtSetArg(args[numargs],XtNtitle,"Open");numargs++;           
          XtSetArg(args[numargs],XtNborderWidth,0);numargs++;
          XtSetArg(args[numargs],XtNjustify,XtJustifyCenter);numargs++;   
        
         
          OpenButton=XtCreateManagedWidget("Open",commandWidgetClass,top,args,numargs);
          XtAddCallback(OpenButton,XtNcallback,ButtonCallback,fb);

          numargs=0;
          XtSetArg(args[numargs],XtNtitle,"Delete");numargs++;           
          XtSetArg(args[numargs],XtNborderWidth,0);numargs++;
          XtSetArg(args[numargs],XtNjustify,XtJustifyCenter);numargs++;   
          XtSetArg(args[numargs],XtNfromVert,OpenButton);numargs++;
         
          DeleteButton=XtCreateManagedWidget("Delete",commandWidgetClass,top,args,numargs);
          fb1=dupFileButton(fb);
          fb1->popup=popup;
          XtAddCallback(DeleteButton,XtNcallback,DeleteCallback,fb1);
         
	 size=ExtCheck_RightClickCallbackName(fb->filename);
	 if(size!=NULL){
          numargs=0;
          XtSetArg(args[numargs],XtNtitle,size);numargs++;           
          XtSetArg(args[numargs],XtNborderWidth,0);numargs++;
          XtSetArg(args[numargs],XtNjustify,XtJustifyCenter);numargs++;   
        
         
          EditButton=XtCreateManagedWidget(size,commandWidgetClass,top,args,numargs);
          XtAddCallback(EditButton,XtNcallback,EditCallback,fb);
          }


}

void closePopupCallback(Widget widget,char *tag,XEvent *xe,Boolean *b)
{
XtDestroyWidget(widget);
}

void PopupDestroyCallback(Widget widget,XtPointer pointer,XEvent *event, Boolean *dispatch)
{
if(pointer!=NULL){  ((struct FileButton *)pointer)->popup=NULL; }
}


void RClickCallback(Widget widget,XtPointer pointer,XEvent* event,Boolean *dispatch)
{
Arg  args[20];
int n;
Widget form;
Widget box;
Atom wm_delete_window;

if(event->type!=ButtonRelease)return;
if((((XButtonEvent *)event)->state & Button3Mask)==0)return;

#ifdef __DEBUG__
printf("%d ",event->type);fflush(stdout);
fprintf(stderr,". ");fflush(stderr);
fprintf(stderr,"%s of type %d\n",((struct FileButton *)pointer)->filename,((struct FileButton *)pointer)->type);
fflush(stderr);
#endif

*dispatch=TRUE;
if(OnlyOnePopup && (popup!=NULL)){ XtPopdown(popup);popup=NULL; }

         n=0; 
        XtSetArg(args[n],XtNwidth,PopupW);n++;
        XtSetArg(args[n],XtNheight,PopupH);n++;
        XtSetArg(args[n],XtNinput,InputOutput);n++;
        XtSetArg(args[n],XtNx,((XButtonEvent *)event)->x_root);n++;
        XtSetArg(args[n],XtNy,((XButtonEvent *)event)->y_root);n++;
        XtSetArg(args[n],XtNtitle,((struct FileButton *)pointer)->filename);n++;
	
        if(((struct FileButton *)pointer)->popup!=NULL){
				XtPopdown(((struct FileButton *)pointer)->popup);
				((struct FileButton *)pointer)->popup=NULL;
				}
        popup=XtCreatePopupShell("RCpopup",transientShellWidgetClass,
                ((struct FileButton *)pointer)->parent,args,n);
	((struct FileButton *)pointer)->popup=popup;	
	XtAddCallback(popup,XtNdestroyCallback,PopupDestroyCallback,pointer);

         XtOverrideTranslations(popup,
         XtParseTranslationTable ("<Message>WM_PROTOCOLS: close2()")); 
      
         
                 n=0;
        XtSetArg(args[n],XtNwidth,PopupW);n++;
        XtSetArg(args[n],XtNheight,PopupH);n++;
        form=XtCreateManagedWidget("form",formWidgetClass,popup,args,n);
         n=0;
        XtSetArg(args[n],XtNhSpace,3);n++;
        XtSetArg(args[n],XtNvSpace,3);n++;
        XtSetArg(args[n],XtNorientation,XtorientVertical);n++;
        XtSetArg(args[n],XtNwidth,PopupW);n++;
        XtSetArg(args[n],XtNheight,PopupH);n++;   
        XtSetArg(args[n],XtNborderWidth,0);n++;   
        box=XtCreateManagedWidget("box",boxWidgetClass,form,args,n);

        

        MakeLayout(popup,box,(struct FileButton *)pointer);


        XtPopup(popup,XtGrabNone);
        wm_delete_window = XInternAtom(XtDisplay(popup), "WM_DELETE_WINDOW", False) ;
       (void) XSetWMProtocols (XtDisplay(popup), XtWindow(popup),
                            &wm_delete_window, 1);
      
       
      
/*exit(0);*/
}



